#!ruby

require 'yarvutil'
puts YARVCore::VERSION + " rev: #{YARVCore::REV} (#{YARVCore::DATE})"
puts YARVCore::OPTS

$line = __LINE__ + 3
###########################################################
$prog =<<'__EOP__'
def fib n
  if n < 2
    1
  else
    fib(n-1) + fib(n-2)
  end
end

fib(30)

__END__
def iter
  yield :x, :y, :z
end

a = c = 0

iter{|x, y|
  iter{|a, b, c|
    p [x, y, a, b, c]
    d = e = 0
    p [x, y, a, b, c, d, e]
  }
}
p [a, c]
__END__

y = nil
2.times{|x|
  2.times{|y|
    p x*y
    z = 1
  }
}

__END__

def m
  y = nil
  size = 2
  size.times{|x|
    size.times{|y|
      p x * y
      z = 0
    }
  }
end
m
__END__
class C
def initialize w=3, h=4
    @width = w
    @height = h
    @lives = {}

    #(A) @neighbors̏
    @neighbors = Array.new(h)
  for y in 0..h - 1
  end

  
  size = 2
  size.times{|x|
    size.times{|y|
      p x * y
    }
  }
end
end

C.new



__EOP__
###########################################################

puts YARVUtil.parse($prog, $0, $line).disasm
exit if ARGV[0] == 'po'

$lpback = $".dup

puts '-----------------------------------------------------------------------------'
$ans = YARVUtil.eval($prog, $0, $line)
puts '-----------------------------------------------------------------------------'
puts "result: #{$ans.inspect}"

$".replace $lpback
puts "ruby  : #{YARVUtil.eval_in_wrap($prog, $0, $line).inspect}"

YARVUtil.dump_usage_analisys

